---
title: IDBObjectStore.put()
slug: Web/API/IDBObjectStore/put
tags:
  - API
  - Database
  - IDBObjectStore
  - IndexedDB
  - Method
  - Reference
  - Storage
  - put
---
<p>{{ APIRef("IndexedDB") }}</p>

<div>
<p>The <strong><code>put()</code></strong> method of the {{domxref("IDBObjectStore")}} interface updates a given record in a database, or inserts a new record if the given item does not already exist.</p>

<p>It returns an {{domxref("IDBRequest")}} object, and, in a separate thread, creates a <a href="http://www.whatwg.org/specs/web-apps/current-work/multipage/common-dom-interfaces.html#structured-clone">structured clone</a> of the value and stores the cloned value in the object store. This is for adding new records, or updating existing records in an object store when the transaction's mode is <code>readwrite</code>. If the record is successfully stored, then a success event is fired on the returned request object with the <code>result</code> set to the key for the stored record, and the <code>transaction</code> set to the transaction in which this object store is opened.</p>
</div>

<p>The put method is an<span class="database"> <em>update or insert</em> </span>method. See the {{domxref("IDBObjectStore.add")}} method for an <em>insert only</em> method.</p>

<p>Bear in mind that if you have a {{domxref("cursor","IDBCursor")}} to the record you want to update, updating it with {{domxref("IDBCursor.update()")}} is preferable to using {{domxref("IDBObjectStore.put()")}}. Doing so makes it clear that an existing record will be updated, instead of a new record being inserted.</p>

<p>{{AvailableInWorkers}}</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">let <em>request</em> = <em>objectStore</em>.put(<em>item</em>);
let <em>request</em> = <em>objectStore</em>.put(<em>item</em>, <em>key</em>);</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt>item</dt>
 <dd>The item you wish to update (or insert).</dd>
 <dt>key {{optional_inline}}</dt>
 <dd>The primary key of the record you want to update (e.g. from {{domxref("IDBCursor.primaryKey")}}). This is only needed for object stores that have an <code>autoIncrement</code> primary key, therefore the key is not in a field on the record object. In such cases, calling <code>put(item)</code> will always insert a new record, because it doesn't know what existing record you might want to modify.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>An {{domxref("IDBRequest")}} object on which subsequent events related to this operation are fired.</p>

<h3 id="Exceptions">Exceptions</h3>

<p>This method may raise a {{domxref("DOMException")}} of one of the following types:</p>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Exception</th>
   <th scope="col">Description</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td><code>ReadOnlyError</code></td>
   <td>The transaction associated with this operation is in read-only <a href="/en-US/docs/IndexedDB/IDBTransaction#mode_constants">mode</a>.</td>
  </tr>
  <tr>
   <td><code>TransactionInactiveError</code></td>
   <td>This {{domxref("IDBObjectStore")}}'s transaction is inactive.</td>
  </tr>
  <tr>
   <td><code>DataError</code></td>
   <td>
    <p>Any of the following conditions apply:</p>

    <ul>
     <li>The object store uses in-line keys or has a key generator, and a key parameter was provided.</li>
     <li>The object store uses out-of-line keys and has no key generator, and no key parameter was provided.</li>
     <li>The object store uses in-line keys but no key generator, and the object store's key path does not yield a valid key.</li>
     <li>The key parameter was provided but does not contain a valid key.</li>
    </ul>
   </td>
  </tr>
  <tr>
   <td><code>InvalidStateError</code></td>
   <td>The {{domxref("IDBObjectStore")}} has been deleted or removed.</td>
  </tr>
  <tr>
   <td><code>DataCloneError</code></td>
   <td>The data being stored could not be cloned by the internal structured cloning algorithm.<br>
     </td>
  </tr>
 </tbody>
</table>

<h2 id="Parameters_2">Parameters</h2>

<dl>
 <dt>value</dt>
 <dd>The value to be stored.</dd>
 <dt>key</dt>
 <dd>The key to use to identify the record. If unspecified, it results to null. If the object store has a key generator (e.g. autoincrement) the key of the object must be passed in to update the object.</dd>
</dl>

<h2 id="Example">Example</h2>

<p>The following example requests a given record title; when that request is successful the <code>onsuccess</code> function gets the associated record from the {{domxref("IDBObjectStore")}} (made available as <code>objectStoreTitleRequest.result</code><span style="line-height: 1.5;">), updates one property of the record, and then puts the updated record back into the object store in another request with <code>put()</code>. For a full working example, see our </span><a href="https://github.com/mdn/to-do-notifications/" style="line-height: 1.5;">To-do Notifications</a><span style="line-height: 1.5;"> app (</span><a href="https://mdn.github.io/to-do-notifications/" style="line-height: 1.5;">view example live</a><span style="line-height: 1.5;">.)</span></p>

<pre class="brush: js">const title = "Walk dog";

// Open up a transaction as usual
const objectStore = db.transaction(['toDoList'], "readwrite").objectStore('toDoList');

// Get the to-do list object that has this title as it's title
const objectStoreTitleRequest = objectStore.get(title);

objectStoreTitleRequest.onsuccess = () =&gt; {
  // Grab the data object returned as the result
  const data = objectStoreTitleRequest.result;

  // Update the notified value in the object to "yes"
  data.notified = "yes";

  // Create another request that inserts the item back into the database
  const updateTitleRequest = objectStore.put(data);

  <span style="font-size: 1rem;">// Log the transaction that originated this request</span>
  console.log("The transaction that originated this request is " + updateTitleRequest.transaction);

  // When this new request succeeds, run the displayData() function again to update the display
  updateTitleRequest.onsuccess = () =&gt; {
    displayData();
  };
};</pre>

<h2 id="Specification"><span style="font-size: 2.14285714285714rem;">Specification</span></h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('IndexedDB', '#dom-idbobjectstore-put', 'put()')}}</td>
   <td>{{Spec2('IndexedDB')}}</td>
   <td></td>
  </tr>
  <tr>
   <td>{{SpecName("IndexedDB 2", "#dom-idbobjectstore-put", "put()")}}</td>
   <td>{{Spec2("IndexedDB 2")}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.IDBObjectStore.put")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/IndexedDB_API/Using_IndexedDB">Using IndexedDB</a></li>
 <li>Starting transactions: {{domxref("IDBDatabase")}}</li>
 <li>Using transactions: {{domxref("IDBTransaction")}}</li>
 <li>Setting a range of keys: {{domxref("IDBKeyRange")}}</li>
 <li>Retrieving and making changes to your data: {{domxref("IDBObjectStore")}}</li>
 <li>Using cursors: {{domxref("IDBCursor")}}</li>
 <li>Reference example: <a class="external" href="https://github.com/mdn/to-do-notifications/tree/gh-pages">To-do Notifications</a> (<a class="external" href="https://mdn.github.io/to-do-notifications/">view example live</a>.)</li>
</ul>
